Next: Memory Usage, Previous: Error reporting, Up: BFD front end [Contents][Index]

### 2.3 Miscellaneous

#### 2.3.1 Miscellaneous functions

#### 2.3.1.1 `bfd_get_reloc_upper_bound`

Synopsis

    long bfd_get_reloc_upper_bound (bfd *abfd, asection *sect);

Description
Return the number of bytes required to store the relocation information associated with section sect attached to bfd abfd. If an error occurs, return -1.

#### 2.3.1.2 `bfd_canonicalize_reloc`

Synopsis

    long bfd_canonicalize_reloc
       (bfd *abfd, asection *sec, arelent **loc, asymbol **syms);

Description
Call the back end associated with the open BFD abfd and translate the external form of the relocation information attached to sec into the internal canonical form. Place the table into memory at loc, which has been preallocated, usually by a call to `bfd_get_reloc_upper_bound`. Returns the number of relocs, or -1 on error.

The syms table is also needed for horrible internal magic reasons.

#### 2.3.1.3 `bfd_set_reloc`

Synopsis

    void bfd_set_reloc
       (bfd *abfd, asection *sec, arelent **rel, unsigned int count);

Description
Set the relocation pointer and count within section sec to the values rel and count. The argument abfd is ignored.

#### 2.3.1.4 `bfd_set_file_flags`

Synopsis

    bfd_boolean bfd_set_file_flags (bfd *abfd, flagword flags);

Description
Set the flag word in the BFD abfd to the value flags.

Possible errors are:

- `bfd_error_wrong_format` - The target bfd was not of object format.
- `bfd_error_invalid_operation` - The target bfd was open for reading.
- `bfd_error_invalid_operation` - The flag word contained a bit which was not applicable to the type of file. E.g., an attempt was made to set the `D_PAGED` bit on a BFD format which does not support demand paging.

#### 2.3.1.5 `bfd_get_arch_size`

Synopsis

    int bfd_get_arch_size (bfd *abfd);

Description
Returns the normalized architecture address size, in bits, as determined by the object file’s format. By normalized, we mean either 32 or 64. For ELF, this information is included in the header. Use bfd_arch_bits_per_address for number of bits in the architecture address.

Returns
Returns the arch size in bits if known, `-1` otherwise.

#### 2.3.1.6 `bfd_get_sign_extend_vma`

Synopsis

    int bfd_get_sign_extend_vma (bfd *abfd);

Description
Indicates if the target architecture "naturally" sign extends an address. Some architectures implicitly sign extend address values when they are converted to types larger than the size of an address. For instance, bfd_get_start_address() will return an address sign extended to fill a bfd_vma when this is the case.

Returns
Returns `1` if the target architecture is known to sign extend addresses, `0` if the target architecture is known to not sign extend addresses, and `-1` otherwise.

#### 2.3.1.7 `bfd_set_start_address`

Synopsis

    bfd_boolean bfd_set_start_address (bfd *abfd, bfd_vma vma);

Description
Make vma the entry point of output BFD abfd.

Returns
Returns `TRUE` on success, `FALSE` otherwise.

#### 2.3.1.8 `bfd_get_gp_size`

Synopsis

    unsigned int bfd_get_gp_size (bfd *abfd);

Description
Return the maximum size of objects to be optimized using the GP register under MIPS ECOFF. This is typically set by the `-G` argument to the compiler, assembler or linker.

#### 2.3.1.9 `bfd_set_gp_size`

Synopsis

    void bfd_set_gp_size (bfd *abfd, unsigned int i);

Description
Set the maximum size of objects to be optimized using the GP register under ECOFF or MIPS ELF. This is typically set by the `-G` argument to the compiler, assembler or linker.

#### 2.3.1.10 `bfd_scan_vma`

Synopsis

    bfd_vma bfd_scan_vma (const char *string, const char **end, int base);

Description
Convert, like `strtoul`, a numerical expression string into a `bfd_vma` integer, and return that integer. (Though without as many bells and whistles as `strtoul`.) The expression is assumed to be unsigned (i.e., positive). If given a base, it is used as the base for conversion. A base of 0 causes the function to interpret the string in hex if a leading "0x" or "0X" is found, otherwise in octal if a leading zero is found, otherwise in decimal.

If the value would overflow, the maximum `bfd_vma` value is returned.

#### 2.3.1.11 `bfd_copy_private_header_data`

Synopsis

    bfd_boolean bfd_copy_private_header_data (bfd *ibfd, bfd *obfd);

Description
Copy private BFD header information from the BFD ibfd to the the BFD obfd. This copies information that may require sections to exist, but does not require symbol tables. Return `true` on success, `false` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

    #define bfd_copy_private_header_data(ibfd, obfd) \
         BFD_SEND (obfd, _bfd_copy_private_header_data, \
                   (ibfd, obfd))

#### 2.3.1.12 `bfd_copy_private_bfd_data`

Synopsis

    bfd_boolean bfd_copy_private_bfd_data (bfd *ibfd, bfd *obfd);

Description
Copy private BFD information from the BFD ibfd to the the BFD obfd. Return `TRUE` on success, `FALSE` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

    #define bfd_copy_private_bfd_data(ibfd, obfd) \
         BFD_SEND (obfd, _bfd_copy_private_bfd_data, \
                   (ibfd, obfd))

#### 2.3.1.13 `bfd_merge_private_bfd_data`

Synopsis

    bfd_boolean bfd_merge_private_bfd_data (bfd *ibfd, bfd *obfd);

Description
Merge private BFD information from the BFD ibfd to the the output file BFD obfd when linking. Return `TRUE` on success, `FALSE` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

    #define bfd_merge_private_bfd_data(ibfd, obfd) \
         BFD_SEND (obfd, _bfd_merge_private_bfd_data, \
                   (ibfd, obfd))

#### 2.3.1.14 `bfd_set_private_flags`

Synopsis

    bfd_boolean bfd_set_private_flags (bfd *abfd, flagword flags);

Description
Set private BFD flag information in the BFD abfd. Return `TRUE` on success, `FALSE` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

    #define bfd_set_private_flags(abfd, flags) \
         BFD_SEND (abfd, _bfd_set_private_flags, (abfd, flags))

#### 2.3.1.15 `Other functions`

Description
The following functions exist but have not yet been documented.

    #define bfd_sizeof_headers(abfd, info) \
           BFD_SEND (abfd, _bfd_sizeof_headers, (abfd, info))

    #define bfd_find_nearest_line(abfd, sec, syms, off, file, func, line) \
           BFD_SEND (abfd, _bfd_find_nearest_line, \
                     (abfd, syms, sec, off, file, func, line, NULL))

    #define bfd_find_nearest_line_discriminator(abfd, sec, syms, off, file, func, \
                                                line, disc) \
           BFD_SEND (abfd, _bfd_find_nearest_line, \
                     (abfd, syms, sec, off, file, func, line, disc))

    #define bfd_find_line(abfd, syms, sym, file, line) \
           BFD_SEND (abfd, _bfd_find_line, \
                     (abfd, syms, sym, file, line))

    #define bfd_find_inliner_info(abfd, file, func, line) \
           BFD_SEND (abfd, _bfd_find_inliner_info, \
                     (abfd, file, func, line))

    #define bfd_debug_info_start(abfd) \
           BFD_SEND (abfd, _bfd_debug_info_start, (abfd))

    #define bfd_debug_info_end(abfd) \
           BFD_SEND (abfd, _bfd_debug_info_end, (abfd))

    #define bfd_debug_info_accumulate(abfd, section) \
           BFD_SEND (abfd, _bfd_debug_info_accumulate, (abfd, section))

    #define bfd_stat_arch_elt(abfd, stat) \
           BFD_SEND (abfd, _bfd_stat_arch_elt,(abfd, stat))

    #define bfd_update_armap_timestamp(abfd) \
           BFD_SEND (abfd, _bfd_update_armap_timestamp, (abfd))

    #define bfd_set_arch_mach(abfd, arch, mach)\
           BFD_SEND ( abfd, _bfd_set_arch_mach, (abfd, arch, mach))

    #define bfd_relax_section(abfd, section, link_info, again) \
           BFD_SEND (abfd, _bfd_relax_section, (abfd, section, link_info, again))

    #define bfd_gc_sections(abfd, link_info) \
           BFD_SEND (abfd, _bfd_gc_sections, (abfd, link_info))

    #define bfd_lookup_section_flags(link_info, flag_info, section) \
           BFD_SEND (abfd, _bfd_lookup_section_flags, (link_info, flag_info, section))

    #define bfd_merge_sections(abfd, link_info) \
           BFD_SEND (abfd, _bfd_merge_sections, (abfd, link_info))

    #define bfd_is_group_section(abfd, sec) \
           BFD_SEND (abfd, _bfd_is_group_section, (abfd, sec))

    #define bfd_discard_group(abfd, sec) \
           BFD_SEND (abfd, _bfd_discard_group, (abfd, sec))

    #define bfd_link_hash_table_create(abfd) \
           BFD_SEND (abfd, _bfd_link_hash_table_create, (abfd))

    #define bfd_link_add_symbols(abfd, info) \
           BFD_SEND (abfd, _bfd_link_add_symbols, (abfd, info))

    #define bfd_link_just_syms(abfd, sec, info) \
           BFD_SEND (abfd, _bfd_link_just_syms, (sec, info))

    #define bfd_final_link(abfd, info) \
           BFD_SEND (abfd, _bfd_final_link, (abfd, info))

    #define bfd_free_cached_info(abfd) \
           BFD_SEND (abfd, _bfd_free_cached_info, (abfd))

    #define bfd_get_dynamic_symtab_upper_bound(abfd) \
           BFD_SEND (abfd, _bfd_get_dynamic_symtab_upper_bound, (abfd))

    #define bfd_print_private_bfd_data(abfd, file)\
           BFD_SEND (abfd, _bfd_print_private_bfd_data, (abfd, file))

    #define bfd_canonicalize_dynamic_symtab(abfd, asymbols) \
           BFD_SEND (abfd, _bfd_canonicalize_dynamic_symtab, (abfd, asymbols))

    #define bfd_get_synthetic_symtab(abfd, count, syms, dyncount, dynsyms, ret) \
           BFD_SEND (abfd, _bfd_get_synthetic_symtab, (abfd, count, syms, \
                                                       dyncount, dynsyms, ret))

    #define bfd_get_dynamic_reloc_upper_bound(abfd) \
           BFD_SEND (abfd, _bfd_get_dynamic_reloc_upper_bound, (abfd))

    #define bfd_canonicalize_dynamic_reloc(abfd, arels, asyms) \
           BFD_SEND (abfd, _bfd_canonicalize_dynamic_reloc, (abfd, arels, asyms))

    extern bfd_byte *bfd_get_relocated_section_contents
      (bfd *, struct bfd_link_info *, struct bfd_link_order *, bfd_byte *,
       bfd_boolean, asymbol **);

#### 2.3.1.16 `bfd_alt_mach_code`

Synopsis

    bfd_boolean bfd_alt_mach_code (bfd *abfd, int alternative);

Description
When more than one machine code number is available for the same machine type, this function can be used to switch between the preferred one (alternative == 0) and any others. Currently, only ELF supports this feature, with up to two alternate machine codes.

#### 2.3.1.17 `bfd_emul_get_maxpagesize`

Synopsis

    bfd_vma bfd_emul_get_maxpagesize (const char *);

Description
Returns the maximum page size, in bytes, as determined by emulation.

Returns
Returns the maximum page size in bytes for ELF, 0 otherwise.

#### 2.3.1.18 `bfd_emul_set_maxpagesize`

Synopsis

    void bfd_emul_set_maxpagesize (const char *, bfd_vma);

Description
For ELF, set the maximum page size for the emulation. It is a no-op for other formats.

#### 2.3.1.19 `bfd_emul_get_commonpagesize`

Synopsis

    bfd_vma bfd_emul_get_commonpagesize (const char *);

Description
Returns the common page size, in bytes, as determined by emulation.

Returns
Returns the common page size in bytes for ELF, 0 otherwise.

#### 2.3.1.20 `bfd_emul_set_commonpagesize`

Synopsis

    void bfd_emul_set_commonpagesize (const char *, bfd_vma);

Description
For ELF, set the common page size for the emulation. It is a no-op for other formats.

#### 2.3.1.21 `bfd_demangle`

Synopsis

    char *bfd_demangle (bfd *, const char *, int);

Description
Wrapper around cplus_demangle. Strips leading underscores and other such chars that would otherwise confuse the demangler. If passed a g++ v3 ABI mangled name, returns a buffer allocated with malloc holding the demangled name. Returns NULL otherwise and on memory alloc failure.

#### 2.3.1.22 `bfd_update_compression_header`

Synopsis

    void bfd_update_compression_header
       (bfd *abfd, bfd_byte *contents, asection *sec);

Description
Set the compression header at CONTENTS of SEC in ABFD and update elf_section_flags for compression.

#### 2.3.1.23 `bfd_check_compression_header`

Synopsis

    bfd_boolean bfd_check_compression_header
       (bfd *abfd, bfd_byte *contents, asection *sec,
        bfd_size_type *uncompressed_size);

Description
Check the compression header at CONTENTS of SEC in ABFD and store the uncompressed size in UNCOMPRESSED_SIZE if the compression header is valid.

Returns
Return TRUE if the compression header is valid.

#### 2.3.1.24 `bfd_get_compression_header_size`

Synopsis

    int bfd_get_compression_header_size (bfd *abfd, asection *sec);

Description
Return the size of the compression header of SEC in ABFD.

Returns
Return the size of the compression header in bytes.

#### 2.3.1.25 `bfd_convert_section_size`

Synopsis

    bfd_size_type bfd_convert_section_size
       (bfd *ibfd, asection *isec, bfd *obfd, bfd_size_type size);

Description
Convert the size size of the section isec in input BFD ibfd to the section size in output BFD obfd.

#### 2.3.1.26 `bfd_convert_section_contents`

Synopsis

    bfd_boolean bfd_convert_section_contents
       (bfd *ibfd, asection *isec, bfd *obfd,
        bfd_byte **ptr, bfd_size_type *ptr_size);

Description
Convert the contents, stored in *ptr, of the section isec in input BFD ibfd to output BFD obfd if needed. The original buffer pointed to by *ptr may be freed and *ptr is returned with memory malloc’d by this function, and the new size written to ptr_size.

#### 2.3.1.27 `struct bfd_iovec`

Description
The `struct bfd_iovec` contains the internal file I/O class. Each `BFD` has an instance of this class and all file I/O is routed through it (it is assumed that the instance implements all methods listed below).

    struct bfd_iovec
    {
      /* To avoid problems with macros, a "b" rather than "f"
         prefix is prepended to each method name.  */
      /* Attempt to read/write NBYTES on ABFD's IOSTREAM storing/fetching
         bytes starting at PTR.  Return the number of bytes actually
         transfered (a read past end-of-file returns less than NBYTES),
         or -1 (setting bfd_error) if an error occurs.  */
      file_ptr (*bread) (struct bfd *abfd, void *ptr, file_ptr nbytes);
      file_ptr (*bwrite) (struct bfd *abfd, const void *ptr,
                          file_ptr nbytes);
      /* Return the current IOSTREAM file offset, or -1 (setting bfd_error
         if an error occurs.  */
      file_ptr (*btell) (struct bfd *abfd);
      /* For the following, on successful completion a value of 0 is returned.
         Otherwise, a value of -1 is returned (and  bfd_error is set).  */
      int (*bseek) (struct bfd *abfd, file_ptr offset, int whence);
      int (*bclose) (struct bfd *abfd);
      int (*bflush) (struct bfd *abfd);
      int (*bstat) (struct bfd *abfd, struct stat *sb);
      /* Mmap a part of the files. ADDR, LEN, PROT, FLAGS and OFFSET are the usual
         mmap parameter, except that LEN and OFFSET do not need to be page
         aligned.  Returns (void *)-1 on failure, mmapped address on success.
         Also write in MAP_ADDR the address of the page aligned buffer and in
         MAP_LEN the size mapped (a page multiple).  Use unmap with MAP_ADDR and
         MAP_LEN to unmap.  */
      void *(*bmmap) (struct bfd *abfd, void *addr, bfd_size_type len,
                      int prot, int flags, file_ptr offset,
                      void **map_addr, bfd_size_type *map_len);
    };
    extern const struct bfd_iovec _bfd_memory_iovec;

#### 2.3.1.28 `bfd_get_mtime`

Synopsis

    long bfd_get_mtime (bfd *abfd);

Description
Return the file modification time (as read from the file system, or from the archive header for archive members).

#### 2.3.1.29 `bfd_get_size`

Synopsis

    file_ptr bfd_get_size (bfd *abfd);

Description
Return the file size (as read from file system) for the file associated with BFD abfd.

The initial motivation for, and use of, this routine is not so we can get the exact size of the object the BFD applies to, since that might not be generally possible (archive members for example). It would be ideal if someone could eventually modify it so that such results were guaranteed.

Instead, we want to ask questions like "is this NNN byte sized object I’m about to try read from file offset YYY reasonable?" As as example of where we might do this, some object formats use string tables for which the first `sizeof (long)` bytes of the table contain the size of the table itself, including the size bytes. If an application tries to read what it thinks is one of these string tables, without some way to validate the size, and for some reason the size is wrong (byte swapping error, wrong location for the string table, etc.), the only clue is likely to be a read error when it tries to read the table, or a "virtual memory exhausted" error when it tries to allocate 15 bazillon bytes of space for the 15 bazillon byte table it is about to read. This function at least allows us to answer the question, "is the size reasonable?".

#### 2.3.1.30 `bfd_mmap`

Synopsis

    void *bfd_mmap (bfd *abfd, void *addr, bfd_size_type len,
        int prot, int flags, file_ptr offset,
        void **map_addr, bfd_size_type *map_len);

Description
Return mmap()ed region of the file, if possible and implemented. LEN and OFFSET do not need to be page aligned. The page aligned address and length are written to MAP_ADDR and MAP_LEN.

Next: Memory Usage, Previous: Error reporting, Up: BFD front end [Contents][Index]